
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#代码验证sql语句是否正确(只验证不执行sql)的方法 / 憋错料</title>

    <meta name="description" content="C#代码验证sql语句是否正确(只验证不执行sql)的方法 转自 :http://www.jquerycn.cn/a_15010 为大家介绍如何用C#验证sql语句的正确性,就像sql查询分析器中的检测代码功能一样,有需要的朋友,可以参考下. 需要用到如下的知识:SET PARSEONLY检查每个 Transact-SQL 语句的语法并返回任何错误消息,但不编译和执行语句.SET PARSEONLY { ON | OFF }当 SET PARSEONLY 为 ON 时,SQL Server 只分析语句.当 SET PARSEONLY 为 OFF 时,SQ">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#代码验证sql语句是否正确(只验证不执行sql)的方法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>转自 ：http://www.jquerycn.cn/a_15010</p>
<p>为大家介绍如何用C#验证sql语句的正确性，就像sql查询分析器中的检测代码功能一样，有需要的朋友，可以参考下。</p>
<p>需要用到如下的知识：<br />SET PARSEONLY<br />检查每个 Transact-SQL 语句的语法并返回任何错误消息，但不编译和执行语句。<br />SET PARSEONLY { ON | OFF }<br />当 SET PARSEONLY 为 ON 时，SQL Server 只分析语句。当 SET PARSEONLY 为 OFF 时，SQL Server 编译并执行语句。<br />SET PARSEONLY 的设置是在分析时设置，而不是在执行或运行时设置。<br />在存储过程或触发器中不要使用 PARSEONLY。如果 OFFSETS 选项为 ON 而且没有出现错误，则 SET PARSEONLY 返回偏移量。<br />SET NOEXEC (Transact-SQL)<br />编译每个查询但不执行查询。<br />SET NOEXEC { ON | OFF }<br />当 SET NOEXEC 为 ON 时，SQL Server 将编译每一批处理 Transact-SQL 语句但并不执行它们。当 SET NOEXEC 设置为 OFF 时，所有批处理将在编译后执行。<br />SQL Server 中的语句执行包含两个阶段：编译和执行。<br />该设置可用于让 SQL Server 在执行 Transact-SQL 代码时，验证代码中的语法和对象名。<br />也可以用于调试通常是较大的批处理中的部分语句。</p>
<p>SET NOEXEC 设置是在执行或运行时设置，而不是在分析时设置。<br />SET PARSEONLY的代码如下：</p>
<pre>public bool ValidateSQL(string sql)
{
bool bResult; 

SqlCommand cmd = _conn.CreateCommand();
cmd.CommandText = "SET PARSEONLY ON";
cmd.ExecuteNonQuery();
try
{
cmd.CommandText = sql;
cmd.ExecuteNonQuery();
bResult = true;
}
catch (Exception ex)
{
bResult = false;
}
finally
{
cmd.CommandText = "SET PARSEONLY OFF";
cmd.ExecuteNonQuery();
} 

return bResult;
}</pre>
<p>有兴趣的朋友，可以亲自测试下，看看效果如何？！<br />可以把以上代码写成类中的方法，以后每次执行时都提前验证下，是不是很酷哦。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 06:56:42 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/www/" title="www&period;">www&period;</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/%e8%ae%be%e7%bd%ae/" title="设置">设置</a>, <a href="https://www.biecuoliao.com/tag/%e9%94%99%e8%af%af/" title="错误">错误</a>, <a href="https://www.biecuoliao.com/tag/jquery/" title="jquery">jquery</a>, <a href="https://www.biecuoliao.com/tag/%e9%80%89%e9%a1%b9/" title="选项">选项</a>, <a href="https://www.biecuoliao.com/tag/%e6%b6%88%e6%81%af/" title="消息">消息</a>, <a href="https://www.biecuoliao.com/tag/finally/" title="finally">finally</a>, <a href="https://www.biecuoliao.com/tag/ndt/" title="ndt">ndt</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#代码验证sql语句是否正确(只验证不执行sql)的方法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pQb1wM.html" rel="bookmark">sql语句or与union all的执行效率比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看到一篇文章是讲sql语句or与union all的执行效率比较的,以前没怎么注意这个问题,感觉文章写的不错,转来一看. 文章原链接:http://www.cunyoulu.com/zhuanti/qtstudy/20081124orunion.htm sql语句or与union all的执行效率比较 当SQL语句有多个or语句时,可以考虑使用union或者union all代替来提高速度.使用or的SQL语句往往无法进行优化,导致速度变慢.但这不是固定的,有时候使用or速度会更快些.具体情况还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nLq5N4.html" rel="bookmark">PHP里的SQL语句是否正确，是否正确执行的检测方法。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP将传过来的值插入数据库,或者向数据库传值的时候,往往出现PHP没有报错,但是数据库并未更新的情况.这个时候 ,你可以用ECHO  打印输POST 或者GET 传过来的值,打印要执行的SQL语句,然后去mysql执行一遍,用mysq_error()函数 显示错误.例 &lt;?php error_reporting(0); $username_value = $_POST['username_input']; $email_value = $_POST['email_input']; $passw			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47DLByM.html" rel="bookmark">SQL语句在数据库中是如何执行的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一步:应用程序把查询SQL语句发给服务器端执行 我们在数据层执行SQL语句时,应用程序会连接到相应的数据库服务器,把SQL语句发送给服务器处理. 第二步:服务器解析请求的SQL语句 SQL计划缓存,经常用查询分析器的朋友大概都知道这样一个事实,往往一个查询语句在第一次运行的时候需要执行特别长的时间,但是如果你马上或者在一定时间内运行同样的语句,会在很短的时间内返回查询结果.原因是: 服务器在接收到查询请求后,并不会马上去数据库查询,而是在数据库中的计划缓存中找是否有相对应的执行计划.如果存在,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyD8O3.html" rel="bookmark">经典SQL语句大全以及50个常用的sql语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经典SQL语句大全 一.基础 1.说明:创建数据库CREATE DATABASE database-name 2.说明:删除数据库drop database dbname3.说明:备份sql server--- 创建 备份数据的 deviceUSE masterEXEC sp_addumpdevice 'disk', 'testBack', 'c:\mssql7backup\MyNwind_1.dat'--- 开始 备份BACKUP DATABASE pubs TO testBack 4.说明:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JAOBl3.html" rel="bookmark">在SQLServer中使用SQL语句插入数据出现乱码或问号的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				错误产生的原因: 出现使用SQL语句插入数据出现乱码或问号是由于数据库属性的排序规则设置不正确. 解决方法: 方法一:手动修改(设置数据库的排序规则) 注意事项:要确定修改的数据库没有被使用,否则会失败! 具体步骤:选中要修改的数据库--&gt;右键--&gt;属性--&gt;弹出数据库属性对话框--&gt;选项--&gt;把排序规则设置成: Chinese_PRC_90_CI_AS--&gt;确定. 方法二:使用代码修改 注意事项:要确定修改的数据库没有被使用,否则会失败!(将数据库连接断开执行这个脚本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n5qzoM.html" rel="bookmark">【sql server inject】使用动态查询执行sql语句实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				应某少年要求授权测试一个存在报错注入点的站点,可读取数据库名,但是sqlmap执行–os-shell选项就会莫名当掉: 分步骤测试了几次,发现xp_cmdshell是开启状态,但用sqlmap注入却无法利用XP_cmdshell执行命令? 正好最近在读[SQL注入攻击与防御],感觉这真是一个值得实践的好目标! 为了简化测试步骤,所以文章分为5次进行记录: 0x1 sqlmap常用语句测试 测试1目的:执行cmd命令 测试1结果,测试初期无法连接: ------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wE9dRM.html" rel="bookmark">用SQL语句添加删除修改字段&lowbar;常用SQL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.增加字段     alter table docdsp     add dspcodechar(200)2.删除字段     ALTER TABLE table_NAME DROP COLUMNcolumn_NAME3.修改字段类型     ALTER TABLE table_name     ALTER COLUMNcolumn_name new_data_type4.sp_rename 改名     EXEC sp_rename '[dbo].[Table_1].[filedName1]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6lg2N3.html" rel="bookmark">表单中通过sql语句，一次操作，执行多个sql，返回多个值的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				范例: &lt;BILLC_EX_INT01 datatype=&quot;float&quot; name=&quot;妥投单量&quot; sql=&quot;SELECT ISNULL(SUM(EXBD_EX_NUM001),0) AS RESULT FROM TEX_BUSINESS_DATA WHERE (EXBD_EX_STR002='$current()/BILLC_EX_STR003$') AND (EXBD_EX_STR003='妥投')▓BILLC_EX_INT02◆SELECT SU			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pqN7PM.html" rel="bookmark">SQL Server自动化运维系列&mdash;&mdash;批量执行SQL脚本（Power Shell）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				需求描述 一般在生产环境中,在投产的情况下,需要批量的来执行SQL脚本文件,来完成整个投产,如果投产文件比较多的情况下,无疑这是一个比较痛苦的过程,所以本篇通过PowerShell脚本来批量完成. 监控脚本 &lt;#批量执行SQL脚本文件#&gt; &lt;#===========================================#&gt; $serverInstance=&quot;WUXUEL1&quot; $Database=&quot;111&quot; #$userName=&q			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/138py3A.html" rel="bookmark" class="title">10&period;4 补充范围内丢失的值</a>
					<div>
						select y.yr.coalesce(x.cnt,0) as cntfrom (select min_year-mod(cast(min_year as int),10)+rn as yrfrom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM68Gr3.html" rel="bookmark" class="title">Sublime Text 3，有了Anaconda就会如虎添翼</a>
					<div>
						作为Python开发环境的Sublime Text 3,有了Anaconda就会如虎添翼.Anaconda是目前最流行也是最有威力的Python代码提示插件. 操作步骤 1.打开package con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35V1JE4.html" rel="bookmark" class="title">讯飞在线语音合成</a>
					<div>
						讯飞在线语音合成 效果图 源码 下载地址(Android Studio工程):http://download.csdn.net/detail/q4878802/9062261 下载SDK 1. 选择服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qo6R5M.html" rel="bookmark" class="title">Let the Balloon Rise&lpar;map&rpar;</a>
					<div>
						Let the Balloon Rise Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Oth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYQyy4.html" rel="bookmark" class="title">Dungeon Game 174</a>
					<div>
						题目描述: 恶魔把公主关到了地牢(m x n 的grid)的右下角,骑士要从左上角的位置出发到达公主所在的位置解救公主 每个位置都有一个hp值,当骑士到达一个位置时,骑士的hp要加上该位置的hp(当该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjnza0.html" rel="bookmark" class="title">POJ1330 Nearest Common Ancestors【最近公共祖先】【Tarjan-LCA算法】</a>
					<div>
						Nearest Common Ancestors Time Limit: 1000MS Memory Limit: 10000K Total Submissions: 19636Accepted: 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjgqA3.html" rel="bookmark" class="title">十二、mysql sql&lowbar;mode 简学</a>
					<div>
						1.一般默认情况下sql_mode默认为空,也就是不严格的sql检查 2.如果sql_mode为空的情况下,测试: create table tt3 (name char(2)); //定义一个nam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qjjV3.html" rel="bookmark" class="title">【宋红康学习日记7】面向对象编程【2】类与方法</a>
					<div>
						1一 匿名类 new Circle();(创建只能使用一次 不可再调用) 二 可变个数形参形式(构成重载) public int getSum(){} public int getSum(int i, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1X1gM.html" rel="bookmark" class="title">Android之Linearlayouy线性布局</a>
					<div>
						写了个小例子xml代码如下: 1 &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; 2 &lt;RelativeLayo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1L8VM.html" rel="bookmark" class="title">Android用NavigationView实现抽屉菜单界面</a>
					<div>
						NavigationView在MD设计中非常重要,之前Google也提出了使用DrawerLayout来实现导航抽屉.这次,在Android Design Support Library中,Googl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aYoqP0.html" rel="bookmark" class="title">Android自学历程&mdash;Material Design的Tabs</a>
					<div>
						好几天没写博客了,今天给大家带来一篇不错的译文.我照着练习了段时间,还有买了新书&lt;android开发艺术探索&gt;,如果好的话给大家分享分享. 用Android Material Design ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZY5G0.html" rel="bookmark" class="title">Mongo：将查询结果转换为自定义类</a>
					<div>
						1.自定义类 public class MyClass { public string Name { get; set; } public int Corners { get; set; } } 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGbEGM.html" rel="bookmark" class="title">部署Replica Sets及查看相关配置</a>
					<div>
						MongoDB 支持在多个机器中通过异步复制达到故障转移和实现冗余.多机器中同一时刻只有一台是用于写操作.正是由于这个情况,为MongoDB 提供了数据一致性的保障.担当Primary 角色的机器能把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35N5do4.html" rel="bookmark" class="title">进程线程（一），基础</a>
					<div>
						Python之 进程和线程 一. 进程的定义: 进程就是一个程序在一个数据集上的一次动态执行过程.进程一般由程序.数据集.进程控制块三部分组成我们编写的程序用来描述进程要完成那些功能以及如何完成:数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9LegM.html" rel="bookmark" class="title">Base64编码及其作用</a>
					<div>
						转http://blog.csdn.net/benbenxiongyuan/article/details/7756912 Base64编码的作用:由于某些系统中只能使用ASCII字符.Base64就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wNN8N0.html" rel="bookmark" class="title">王琳闹矛盾 撕破脸打嘴仗&lpar;图&rpar;</a>
					<div>
						www.roadqu.com/profile/1619912/followings www.roadqu.com/profile/1619853/followings www.roadqu.com/p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ogW23.html" rel="bookmark" class="title">Docker源码分析（一）：Docker架构</a>
					<div>
						[编者按]在&lt;深入浅出Docker&gt;系列文章的基础上,InfoQ推出了&lt;Docker源码分析&gt;系列文章.&lt;深入浅出Docker&gt;系列文章更多的是从使用角度出发,帮助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgmxwn3.html" rel="bookmark" class="title">hive如何应对数据倾斜</a>
					<div>
						数据倾斜 概念:数据倾斜是指,map /reduce程序执行时,reduce节点大部分执行完毕,但是 有一个或者几个reduce节点运行很慢,导致整个程序的处理时间很长,这是因为某一 个key的条数比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgmkNK3.html" rel="bookmark" class="title">table中tr使用toggle不好，选择换一张方式</a>
					<div>
						好几次遇到的问题,都是table中tr后面有一部分内容要显示,也是用tr装的,但是需要点击该行,后面那个tr才显示出来.不过最好不要用toggle去写,因为着实效果不佳.故而建议换一种方式,也许最简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JlQBV0.html" rel="bookmark" class="title">封装WebAPI客户端，附赠Nuget打包上传VS拓展工具</a>
					<div>
						一.前言 上篇&lt; WebAPI使用多个xml文件生成帮助文档 &gt;有提到为什么会出现基于多个xml文件生成帮助文档的解决方案,因为定义的模型可能的用处有: 1:单元测试 2:其他项目引用(可 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
